/************************************************************************/
/*  Copyright (C), 2016-2020, [IT], Ȩ;
/*  ģ  ;
/*      ǰĿݿʵ;
/*
/*      [V];	
/*      ߣ[IT];
/*      ڣ[11/13/2016];
/*
/*
/*  ע    ⣺;
/*
/*  ޸ļ¼[IT];
/*  ޸ڣ;
/*  ޸İ汾;
/*  ޸ݣ;
/************************************************************************/
#ifndef __DATA_IMPL__
#define __DATA_IMPL__

#pragma once

#include <vector>
#include "TableInfo.h"

class CDataImpl
{
	//CDataImpl(void);
public:
	CDataImpl(void);
// 	static CDataImpl* GetInstance()
// 	{
// 		static CDataImpl *pObj = NULL;
// 		if ( pObj == NULL )
// 		{
// 			pObj = new CDataImpl;
// 			pObj->Open();
// 		}
// 
// 		return pObj;
// 	}

	virtual ~CDataImpl(void);

	// ˽б;
private:
	sqlite3		*m_psqlite3;
	CHAR		*m_pszErrmsg;

	// û;
public:
	BOOL Open();
	void Close();

	// begin;
	BOOL TransactionBegin()
	{
		INT nRet = sqlite3_exec(m_psqlite3, "begin;", 0, 0, &m_pszErrmsg);
		return ( nRet == 0 ) ? TRUE : FALSE;
	}

	// commit;
	BOOL TransactionCommit()
	{
		INT nRet = sqlite3_exec(m_psqlite3, "commit;", 0, 0, &m_pszErrmsg);
		return ( nRet == 0 ) ? TRUE : FALSE;
	}

	// ִ;
	BOOL ExecteSQL(IN LPCSTR lpSQL);
	// ѯǷ;
	BOOL QueryTable(std::string table);

	// ݶŲѯϢ;
	INT QueryMidInfo(std::string order, STMid &data);
	INT QueryKeyInfo(std::string sn, STKeys &data);
	INT QueryUnReportKeyInfo(std::vector<STKeys> &vtdata);
	INT QueryLogInfo(std::string sn, STLog &data);
	INT QueryUnReportLogInfo(std::vector<STLog> &vtdata);

	// midϢ;
	INT InsertMidInfo(STMid &data);
	// sn keyϢ;
	INT InsertKeyInfo(STKeys &data);
	// log;
	INT InsertLogInfo(STLog &data);

	// keys;
	INT BatchInsertKeyInfo(std::vector<STKeys> &vtdata);

	// ״̬;ɹʱʱ䣩
	BOOL UpdateDownloadStatus(std::string order, int status, std::string des = "" /*ʧ*/);
	// ³д״̬;
	BOOL UpdateKeyCopyStatus(std::string sn, int status);
	// ϱ״̬;
	BOOL UpdateKeyReportStatus(std::string sn, int status);
	// ־ϱ״̬;
	BOOL UpdateLogReportStatus(std::string sn, std::string type, int status);
};

#endif