#ifndef __TABLE_INFO__
#define __TABLE_INFO__

// MID;
#define _CREATE_MID_TABLE_ \
"CREATE TABLE mid \
(bid  TEXT(16) NOT NULL,\
number  INTEGER NOT NULL,\
pid  INTEGER NOT NULL,\
ctype  TEXT(32) NOT NULL,\
version  TEXT(32) NOT NULL,\
purl  TEXT NOT NULL,\
psize  INTEGER NOT NULL,\
pmd5  TEXT(32) NOT NULL,\
status  INTEGER NOT NULL DEFAULT 0,\
start_date  DATETIME DEFAULT current_timestamp,\
finish_date  DATETIME DEFAULT '',\
des  TEXT NOT NULL DEFAULT \"δ\",\
PRIMARY KEY (bid ASC));"
#define _SELECT_MID_TABLE_ "SELECT bid, number, pid, ctype, version, purl, psize, pmd5, status, start_date, finish_date, des FROM mid"
#define _INSERT_MID_TABLE_ "INSERT INTO mid(bid, number, pid, ctype, version, purl, psize, pmd5)VALUES\
(%s, %s, %s, %s, %s, %s, %s, %s);"

// KeyCopy;
#define _CREATE_KEYS_TABLE_ \
"CREATE TABLE keys \
(sn  TEXT(32) PRIMARY KEY NOT NULL,\
keys  TEXT NOT NULL,\
copy_date  DATETIME DEFAULT '',\
report_date  DATETIME DEFAULT '',\
copy_status  INTEGER NOT NULL DEFAULT 0,\
report_status  INTEGER NOT NULL DEFAULT 0);"
#define _SELECT_KEYS_TABLE_ "SELECT sn, keys, copy_date, report_date, copy_status, report_status FROM keys"

// Log;
#define _CREATE_LOG_TABLE_ \
"CREATE TABLE log \
(type  TEXT(32) NOT NULL,\
sn  TEXT NOT NULL,\
content  TEXT NOT NULL,\
gdate  DATETIME DEFAULT current_timestamp,\
report_date  DATETIME DEFAULT '',\
report_status  INTEGER NOT NULL DEFAULT 0,\
PRIMARY KEY (type, sn));"
#define _SELECT_LOG_TABLE_ "SELECT type, sn, content, gdate, report_status FROM log"

// ر;
typedef struct	__ST_MID__
{
	std::string		order;							// ;
	std::string		number;							// ;
	std::string		pid;							// pid;
	std::string		ctype;							// client type;
	std::string		version;						// 汾;
	std::string		purl;							// ַ;
	std::string		psize;							// С;
	std::string		pmd5;							// md5;
	std::string		status;							// ״̬0=δأ1=ɣ-1=ʧ;
	std::string		start_date;						// ؿʼʱ;
	std::string		finish_date;					// ʱ;
	std::string		dsize;							// شС;
	std::string		file;							// ļ·;
	std::string		des;							// ״̬ʧԭ;
}STMid, *pSTMid;

// д;
typedef struct __ST_KEYS__
{
	std::string		sn;								// sn;
	std::string		keys;							// keyJsonַ;
	std::string		copy_date;						// дɹʱ;
	std::string		report_date;					// ϱʱ;
	std::string		copy_status;					// д״̬0=δд-1=дʧܡ1=дɹ;
	std::string		report_status;					// ϱ״̬0=δϱ1=ϱɹ-1=ϱʧ;
}STKeys, *pSTKeys;

// ־;
typedef struct __ST_LOG__
{
	std::string		type;							// ־;
	std::string		sn;								// sn;		
	std::string		content;						// ־;
	std::string		gdate;							// ־ʱ;
	std::string		report_date;					// ־ϱʱ;
	std::string		report_status;					// ϱ״̬0=δϱ1=ϱɹ-1=ϱʧ;
}STLog, *pSTLog;
#endif